<div
  #testDialogs
  [id]="'itb-tests-execution-' + data.testExecutionStatus.testExecution.id"
  [ngStyle]="{ display: minimized ? 'none' : 'contents' }"
>
  <mat-toolbar class="itb-header mat-elevation-z1">
    @if (testRunning && !data.isHistoryItem) {
      <button
        class="fs-18 fw-500"
        mat-button
        color="primary"
        [disabled]="!submittedTest"
        (click)="minimizeConformanceTests()"
      >
        <mat-icon class="minimize-icon fs-24 fw-700">minimize</mat-icon>
        Minimize
      </button>
    } @else {
      <button
        class="fs-18 fw-500"
        mat-button
        color="primary"
        (click)="closeDialog()"
      >
        <mat-icon class="close-icon fs-24 fw-700">close</mat-icon>
        Close
      </button>
    }
    <span class="spacer"></span>

    @if (testRunning && !data.isHistoryItem) {
      <button
        mat-stroked-button
        color="warn"
        class="stop-button"
        (click)="stopTestsExecution()"
      >
        Stop conformance test
      </button>
    } @else {
      <button
        mat-flat-button
        color="primary"
        class="reports-button"
        (click)="downloadAllReports()"
      >
        Download all reports
      </button>
    }
  </mat-toolbar>

  <h2 class="title bg-eu mb-0">Conformance Test</h2>

  <section class="execution-summary bg-eu d-flex align-items-start">
    <div class="w-33 d-flex flex-column align-items-start">
      <div class="mt-1">
        <h3 class="mt-0 mb-0">
          {{ data.testExecutionStatus.testExecution.componentName }}
        </h3>
        <h3 class="mt-0 mb-0">
          Test #{{ data.testExecutionStatus.testExecution.id }}
        </h3>
      </div>

      <br />

      <div class="fs-16">
        <mat-icon
          class="cached-icon"
          [ngClass]="{
            'infinite-rotation': testRunning && !data.isHistoryItem
          }"
        >
          cached
        </mat-icon>
        <span>
          {{
            ongoingNumber
              ? ongoingNumber +
                "/" +
                data.testExecutionStatus.testExecution.totalTestsNumber
              : 0
          }}
          Test cases ongoing
        </span>
      </div>

      <br />

      <div class="slabs-comp ec-chips-theme d-flex">
        <span class="mr-4px">
          {{
            data.testExecutionStatus.testExecution.passedTestsNumber +
              "/" +
              data.testExecutionStatus.testExecution.totalTestsNumber
          }}
        </span>
        <mat-chip
          highlighted
          class="slabs-chip"
          [color]="status2ChipColor.get('Success'.toUpperCase())"
        >
          Success
        </mat-chip>

        <span class="ml-1 mr-4px">
          <!-- {{
            (data.testExecutionStatus.testExecution.failedTestsNumber > 0
              ? data.testExecutionStatus.testExecution.failedTestsNumber
              : 0) +
              "/" +
              data.testExecutionStatus.testExecution.totalTestsNumber
          }} -->
          {{
            (ongoingNumber +
              undefinedNumber +
              data.testExecutionStatus.testExecution.passedTestsNumber <
            data.testExecutionStatus.testExecution.totalTestsNumber
              ? data.testExecutionStatus.testExecution.totalTestsNumber -
                ongoingNumber -
                undefinedNumber -
                data.testExecutionStatus.testExecution.passedTestsNumber
              : 0) +
              "/" +
              data.testExecutionStatus.testExecution.totalTestsNumber
          }}
        </span>
        <mat-chip
          highlighted
          class="slabs-chip"
          [color]="status2ChipColor.get('Failure'.toUpperCase())"
        >
          Failure
        </mat-chip>
      </div>
    </div>
    <div class="h-100 d-flex mt-1">
      <div class="d-flex flex-column justify-content-between">
        <div>
          <div>START TIME</div>
          <div class="fs-22 mt-8px">
            @if (startTime) {
              {{ startTime | date: "dd/M/yyyy" }}
              <b>
                {{ startTime | date: "HH:mm:ss" : "UTC +4" }}
              </b>
            } @else {
              /
            }
          </div>
        </div>

        <div>
          <div>DURATION</div>
          <div class="fs-22 mt-8px">
            <b>
              {{ endTime ? elapsedTime(startTime, endTime) : duration }}
            </b>
          </div>
        </div>
      </div>
      <div class="d-flex flex-column ml-3">
        <div>END TIME</div>
        <div class="fs-22 mt-8px">
          @if (endTime) {
            {{ endTime | date: "dd/M/yyyy" }}
            <b>
              {{ endTime | date: "HH:mm:ss" : "UTC +4" }}
            </b>
          } @else {
            /
          }
        </div>
      </div>
    </div>
  </section>

  <br />
  <br />

  <section class="test-cases-section">
    <mat-accordion togglePosition="before">
      <mat-expansion-panel expanded class="specification-panel border-grey-500">
        <mat-expansion-panel-header>
          <mat-panel-title>
            {{ data.testExecutionStatus.testExecution.specificationName }}
          </mat-panel-title>

          <mat-panel-description class="align-items-center mr-3">
            <b>Spec. last update</b>&nbsp;&nbsp;
            {{
              data.testExecutionStatus.testExecution.specificationLastUpdate
                | date: "dd/M/yyyy"
            }}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

            <span class="spacer"></span>

            <b>Status</b>&nbsp;&nbsp;
            <div class="slabs-comp ec-chips-theme">
              <mat-chip
                highlighted
                class="slabs-chip"
                [color]="
                  status2ChipColor.get(
                    data.testExecutionStatus.testExecution.status.toUpperCase()
                  )
                "
              >
                {{ data.testExecutionStatus.testExecution.status }}
              </mat-chip>
            </div>
          </mat-panel-description>
        </mat-expansion-panel-header>
        <app-itb-tests-execution-table
          [testRunning]="testRunning"
          [testCasesList$]="testCasesList$"
          [duration]="duration"
          [isHistoryItem]="data.isHistoryItem!"
        ></app-itb-tests-execution-table>
      </mat-expansion-panel>
    </mat-accordion>
  </section>
</div>
